| Earth Observation Mission CFI Software DataHandling Software User Manual |

Public Member Functions | Public Attributes

# EECFI::OrbitFile Class Reference

Class for reading/writing orbit files. More...

Inheritance diagram for EECFI::OrbitFile:

List of all members.

## Public Member Functions
| OrbitFile ()
| Empty constructor.
| OrbitFile (const string fileNam)
| Constructor with file name.
| ~OrbitFile ()
| Destructor.
void | read (const bool readFroFlag, const bool readingOsvFlag) throw (CfiError)
| Read the whole file data block.
void | read (const bool readFroFlag, const double startRange, const double stopRange, const bool readingOsvFlag) throw (CfiError)
| Read the file data block between startRange and stopRange in orbits.
void | read (const bool readFroFlag, const long timeRef, const double startRange, const double stopRange, const bool readingOsvFlag) throw (CfiError)
| Read the file data block between startRange and stopRange in days.
void | write (const string fileNam, FixedHeader &fixedHead, vector< OsvRec > &osvData) throw (CfiError)
| Write the file.
void | decimate (double decimationDeltaTime, OrbitFile &osvOut) throw (CfiError)
| Decimate the list of orbit state vectors according to input delta time.
long | xsltAdd () throw (CfiError)
| Add xslt reference with default stylesheet.
## Public Attributes
vector< OsvRec > | osvRec
| Vector of state vectors.

## Detailed Description

Class for reading/writing orbit files.

## Constructor & Destructor Documentation

EECFI::OrbitFile::OrbitFile | ( |  | ) |

Empty constructor.

References EECFI::EEFile::fileType.

EECFI::OrbitFile::OrbitFile | ( | const string | fileNam | ) |

Constructor with file name.

EECFI::OrbitFile::~OrbitFile | ( |  | ) |

Destructor.

References EECFI::EEFile::fixedHeader, and osvRec.

## Member Function Documentation

void EECFI::OrbitFile::decimate | ( | double | decimationDeltaTime,
|  | OrbitFile & | osvOut |
| ) |  |  | throw (CfiError)

Decimate the list of orbit state vectors according to input delta time.

Being t0 the time of the 1st state vector of input list (calling object) and D the decimationDeltaTime, the state vectors from the input list that will be included in the output list will be those closer to every time t=t0+k*D (k=1,2...n). Important: the fixed header of calling object must have been read.

Parameters:

  | decimationDeltaTime | Number of seconds used for decimation.
  | osvOut | Output Orbit File with the decimated list and corresponding Fixed header.

References EECFI::CfiError::addMsg().

void EECFI::OrbitFile::read | ( | const bool | readFroFlag,
|  | const bool | readingOsvFlag |
| ) |  |  | throw (CfiError)

Read the whole file data block.

Parameters:

  | readFroFlag | Type of input file: "true" for ROF and DORIS files "false" for POF files.
  | readingOsvFlag | Select if state vectors are read (true) or only times and orbit numbers (false).

void EECFI::OrbitFile::read | ( | const bool | readFroFlag,
|  | const double | startRange,
|  | const double | stopRange,
|  | const bool | readingOsvFlag |
| ) |  |  | throw (CfiError)

Read the file data block between startRange and stopRange in orbits.

Parameters:

  | readFroFlag | Type of input file: "true" for ROF and DORIS files "false" for POF files.
  | readingOsvFlag | Select of state vectors are read (true) or only times and orbit numbers (false).
  | startRange | Start orbit.
  | stopRange | Stop orbit.

void EECFI::OrbitFile::read | ( | const bool | readFroFlag,
|  | const long | timeRef,
|  | const double | startRange,
|  | const double | stopRange,
|  | const bool | readingOsvFlag |
| ) |  |  | throw (CfiError)

Read the file data block between startRange and stopRange in days.

Parameters:

  | readFroFlag | Type of input file: "true" for ROF and DORIS files "false" for POF files.
  | readingOsvFlag | Select of state vectors are read (true) or only times and orbit numbers (false).
  | startRange | Start day.
  | stopRange | Stop day.
  | timeRef | Time reference.

void EECFI::OrbitFile::write | ( | const string | fileNam,
|  | FixedHeader & | fixedHead,
|  | vector< OsvRec > & | osvData |
| ) |  |  | throw (CfiError)

Write the file.

Parameters:

  | fileNam | Name of the file to write.
  | fixedHead | FixedHeader object with fixed header data.
  | osvData | Vector of state vectors.

long EECFI::OrbitFile::xsltAdd | ( |  | ) | throw (CfiError)

Add xslt reference with default stylesheet.

References EECFI::EEFile::fileName.

## Member Data Documentation

vector<OsvRec> EECFI::OrbitFile::osvRec

Vector of state vectors.

Referenced by ~OrbitFile().